/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ryuuji.servlet.estudiante;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import logica.ExNihilo;
import logica.Search;
import logica.Utilities;
import orm.Apoderado;
import orm.Curso;

/**
 *
 * @author ryuuji
 */
@WebServlet(name = "CrearEstudiante", urlPatterns = {"/CrearEstudiante"})
public class CrearEstudiante extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        String nombre = request.getParameter("nombre");
        String apoderadoRut = request.getParameter("apoderado");
        String cursoString = request.getParameter("cursoCrear");
        if (!nombre.equals("")) {
            if (!request.getParameter("rut").equals("") && !request.getParameter("id").equals("")) {
                if (Utilities.validarRut((String) request.getParameter("rut"), (String) request.getParameter("id"))) {
                    String rut = (String) request.getParameter("rut") + (String) request.getParameter("id");
                    if (!apoderadoRut.equals("")) {
                        Apoderado apoderado = Search.buscarApoderado(apoderadoRut);
                        if (apoderado != null) {
                            if (!cursoString.equals("")) {
                                Curso curso = Search.buscarCurso(Integer.parseInt(cursoString.split("-")[0]), cursoString.split("-")[1]);
                                if (curso != null) {
                                    if (Search.buscarProfesor(rut) == null && Search.buscarApoderado(rut) == null && Search.buscarEstudiante(rut) == null) {
                                        if (Search.buscarEstudiante(rut)==null) {
                                            if (ExNihilo.crearEstudiante(nombre, rut, curso, apoderado)) {
                                                request.getRequestDispatcher("EstudiantesServlet").forward(request, response);
                                            } else {
                                                request.setAttribute("errorCrear", "A ocurrido un error innesperado");
                                                request.getRequestDispatcher("EstudiantesServlet").forward(request, response);
                                            }
                                        } else {
                                            request.setAttribute("errorCrear", "Ya existe el estudiante");
                                            request.getRequestDispatcher("EstudiantesServlet").forward(request, response);
                                        }
                                    } else {
                                        request.setAttribute("errorCrear", "Ya esta utilizado el rut");
                                        request.getRequestDispatcher("EstudiantesServlet").forward(request, response);
                                    }
                                } else {
                                    request.setAttribute("errorCrear", "El curso no existe");
                                    request.getRequestDispatcher("EstudiantesServlet").forward(request, response);
                                }
                            } else {
                                request.setAttribute("errorCrear", "No hay curso seleccionado");
                                request.getRequestDispatcher("EstudiantesServlet").forward(request, response);
                            }
                        } else {
                            request.setAttribute("errorCrear", "El apoderado no existe");
                            request.getRequestDispatcher("EstudiantesServlet").forward(request, response);
                        }
                    } else {
                        request.setAttribute("errorCrear", "No hay apoderado seleccionado");
                        request.getRequestDispatcher("EstudiantesServlet").forward(request, response);
                    }
                } else {
                    request.setAttribute("errorCrear", "El ingresado rut no es valido");
                    request.getRequestDispatcher("EstudiantesServlet").forward(request, response);
                }
            } else {
                request.setAttribute("errorCrear", "Debe ingresar un rut");
                request.getRequestDispatcher("EstudiantesServlet").forward(request, response);
            }
        } else {
            request.setAttribute("errorCrear", "Debe ingresar un nombre");
            request.getRequestDispatcher("EstudiantesServlet").forward(request, response);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
